LifeGrid lg; //init grid

int r, g, b = 0;//colour management
int rD, gD, bD = 0;
boolean rDir, gDir, bDir, rdDir, gdDir, bdDir= true;

long previousMillis = 0; //timing for Conway rules
int interval = 2000;

import processing.serial.*;
Serial myPort;     //serial ports
Serial myPort2;    
 
 
void setup () {
  ellipseMode(CORNER);//circle positioning
  
  // set the window size:
  size(800, 700);        
  
  // set inital background:
  background(0);
  
  g = 128; //color inits
  b = 255;
  rD = 210;
  gD = 105;
  bD = 30;
 
  //make grid 
  lg = new LifeGrid(8,4);
  
 /* MAKE A GLIDER DEMO
  lg.initSquare(1,0);
  lg.initSquare(2,1);
  lg.initSquare(2,2);
  lg.initSquare(1,2);
  lg.initSquare(0,2);*/
  
  // List all the available serial ports
  println(Serial.list());//for debug sake
   
  //get input from Arduino 1
  myPort = new Serial(this, Serial.list()[0], 9600);
  // don't generate a serialEvent() unless you get a newline character:
  myPort.bufferUntil('\n'); 
   
  //get input from Arduino 2
  myPort2 = new Serial(this, Serial.list()[2], 9600);
  // don't generate a serialEvent() unless you get a newline character:
  myPort2.bufferUntil('\n');
}
 
void draw () {
  //make new colours
  colorShift();
  color tempC =  color(r,g,b);
  color temp2C =  color(rD,gD,bD);
  //update tile for if it is safe
  lg.checkForDeath();
  //draw board
  lg.displayState(100, tempC,temp2C);
  
  //interval check
  long currentMillis = millis();
  if(currentMillis - previousMillis > interval){//when update time
    previousMillis = currentMillis;//reset counter
    lg.update();//update grid
    println();//debug data formatting
  }
}
 
 
void serialEvent (Serial myPort) {
 // get the ASCII string:
 String inString = myPort.readStringUntil('\n');
 //vars for instance management
 String splitOn = "";
 int insertRow = 0;
 
 boolean ok = false;
 //once there is input
 if (inString != null) {
   // trim off any whitespace:
   inString = trim(inString);
      
   if (inString.startsWith("d")){//row 1
     insertRow = 3;
     splitOn = "d";
     ok = true;
   }
   if (inString.startsWith("e")){//row 4
     insertRow = 0;
     splitOn = "e";
     ok = true;
   }
   if (inString.startsWith("f")){//row 2
     insertRow = 2;
     splitOn = "f";
     ok = true;
   }
   if (inString.startsWith("g")){//row 3
     insertRow = 1;
     splitOn = "g";
     ok = true;
   }
   
   //accepted string
   if (ok){
     //cut off row identifier
     String[] list = split(inString, splitOn);
     //split along commas
     String[] reallist = split(list[1], ",");
     //init colour to default
     int fillColour = 0;
     //for each grid item
     for (int n=0; n < reallist.length; n++){
      try{
         //get integer value
         int temp = Integer.parseInt(reallist[n]);
         //print it (for debug)
         print (temp);
         print (",");
         //if covered will give 0
         if (temp == 0){
           lg.initSquare(n,insertRow);//set associated square
     //      lg.displayState(100);//redraw
         }
       }
       catch(NumberFormatException e){
         print("oops");//serial info got messed up
       }
     }
     //print new line (for debug)
     println();  
   } 
 }
}

//this part is long and boring it just cycles new colours semi randomly for 
//living and dead cells
void colorShift(){
  if (rDir){
   if(r < 120){
    r+=int(random(5));
   }
   else {
     rDir = false;
     r-=int(random(5));
   }
  }
  else {
    if (r > 0){
      r-=int(random(5));
    }
    else {
      rDir = true;
    }
  }
  
  if (gDir){
   if(g < 255){
    g+=int(random(5));
   }
   else {
     gDir = false;
     g-=int(random(5));
   }
  }
  else {
    if (g > 100){
      g-=int(random(5));
    }
    else {
      gDir = true;
    g+=int(random(5));
    }
  }
  
  if (bDir){
   if(b < 255){
    b+=int(random(5));
   }
   else {
     bDir = false;
     b-=int(random(5));
   }
  }
  else {
    if (b > 0){
      b-=int(random(5));
    }
    else {
      bDir = true;
    b+=int(random(5));
    }
  }
  ///////////////////////////DEATH COLOURS////////////
 if (rdDir){
   if(rD < 255){
    rD+=int(random(2));
   }
   else {
     rdDir = false;
     rD-=int(random(2));
   }
  }
  else {
    if (rD > 160){
      rD-=int(random(2));
    }
    else {
      rdDir = true;
    }
  }
  
  if (gdDir){
   if(gD < 105){
    gD+=int(random(2));
   }
   else {
     gdDir = false;
     gD-=int(random(2));
   }
  }
  else {
    if (gD > 75){
      gD-=int(random(2));
    }
    else {
      gdDir = true;
    gD+=int(random(2));
    }
  }
  
  if (bdDir){
   if(bD < 50){
    bD+=int(random(2));
   }
   else {
     bdDir = false;
     bD-=int(random(2));
   }
  }
  else {
    if (bD > 0){
      bD-=int(random(2));
    }
    else {
      bdDir = true;
    bD+=int(random(2));
    }
  }
}
